// SPDX-License-Identifier: GPL-3.0
//
// Copyright (C) 2019, Donald Dugger
//

import document from "document";
import * as C from "../common/constants";
import { logger } from "../common/utils";
import * as utils from "../common/utils";

let V;
let O;

export function init(_V, _O)
{

  V = _V;
  O = _O;

  if (!O.length)
    O.length = V.G.event_length;
  if (!O.alarm)
    O.alarm = V.G.event_alarm;
  
  if (!O.length)
    O.length = 0;
  if (!O.alarm)
    O.alarm = 0;

  utils.text_btn("um_btn", "Event", "fb-white", "fb-blue", (btn) => {
    utils.bounce("event", V, O);
  });
  
  utils.text_btn("save", "Save", "fb-black", "fb-green", (btn) => {
    save_event();
    utils.bounce("event", V, O);
  });
  let y_btn = document.getElementById("save");
  let y_txt = y_btn.getElementById("b_text");
  y_txt.x = 76;

  utils.text_btn("delete", "Delete", "fb-black", "fb-red", (btn) => {
    rm_event();
    utils.bounce("event", V, O);
  });
  let n_btn = document.getElementById("delete");
  let n_txt = n_btn.getElementById("b_text");
  n_txt.x = 100;

  utils.text_btn("start", utils.min2str(O.start, false, V.G.P), undefined, undefined, (btn) => {
    utils.bounce("get_time", V, {
                                caller: "set_event",
                                opt: O,
                                no_digs: 4,
                                off: O.start * 60,
                                save: save_start
                              });
  });

  utils.text_btn("length", utils.min2str(O.length, false), undefined, undefined, (btn) => {
    utils.bounce("get_time", V, {
                                caller: "set_event",
                                opt: O,
                                no_digs: 4,
                                off: O.length * 60,
                                save: save_length
                              });
  });

  utils.text_btn("alarm", utils.min2str(O.alarm, false), undefined, undefined, (btn) => {
    utils.bounce("get_time", V, {
                                caller: "set_event",
                                opt: O,
                                no_digs: 4,
                                off: O.alarm * 60,
                                save: save_alarm
                              });
  });

  utils.text_btn("name", O.name, undefined, undefined, (btn) => {
    utils.bounce("busy_ids", V, O);
  });

  return false;
}

function save_start(off, _O)
{

  _O.start = parseInt(off/60);
}

function save_length(off, _O)
{

  _O.length = parseInt(off/60);
}

function save_alarm(off, _O)
{

  _O.alarm = parseInt(off/60);
}

function save_event()
{

  let e = {
    index: O.index,
    start: O.start,
    length: O.length,
    alarm: O.alarm,
    type: O.name
  };
  V.G.event_length = O.length;
  V.G.event_alarm = O.alarm;
  utils.add_event(O.index, O.year, O.month, O.day, e)
}

function rm_event()
{

  utils.rm_event(O.index, O.year, O.month, O.day)
}
